﻿
Public Class Form1

    Public WithEvents Films As FilmCollection
    Public listeFilm As List(Of Film)

    Private Sub ListingToListView()

        ListView1.Clear()

        Dim col As New ColumnHeader
        col.Name = "dir"
        col.Text = "directory"
        ' col.Width = 0

        With ListView1.Columns
            .Add(col)
            .Add("name", "Name")
            .Add("nbFile", "nb File")
            .Add("filename", "Fichier")
            .Add("durée", "durée")
            .Add("FileSize", "FileSize")
            .Add("GetInfos", "GetInfos")
            .Add("SendToPhp", "SendToPhp")
        End With

        Dim lvc As New ListView.ListViewItemCollection(ListView1)

        Dim row As ListViewItem
        For Each film In Films.Films

            For Each FichierVideo As Video In film.Videos

                Dim r As String() = {film.Path, film.Name, film.NbFichierVideo, FichierVideo.Name, FichierVideo.GeneralInfos("Duration/String3"), FichierVideo.GeneralInfos("FileSize"), Nothing}

                row = New ListViewItem(r)

                AddHandler FichierVideo.ExtractionGeneraleTermine, AddressOf MajLVExtraction
                row.Name = FichierVideo.FullPath

                lvc.Add(row)

            Next

        Next

    End Sub

    Private Sub MajLVExtraction(ByVal sender As Object, ByVal e As ExtractionGeneraleTermineEventArgs)
        Dim source As Video = sender

        ListView1.Items(source.FullPath).SubItems(ListView1.Columns.IndexOfKey("durée")).Text = source.GeneralInfos("Duration/String3")
        ListView1.Items(source.FullPath).SubItems(ListView1.Columns.IndexOfKey("FileSize")).Text = source.GeneralInfos("FileSize")
        ListView1.Items(source.FullPath).SubItems(ListView1.Columns.IndexOfKey("GetInfos")).Text = "Ok"
        ListView1.Update()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Parcourir.Click
        Dim FolderBrowser As New FolderBrowserDialog
        FolderBrowser.SelectedPath = My.Computer.FileSystem.SpecialDirectories.MyDocuments

        If FolderBrowser.ShowDialog = Windows.Forms.DialogResult.OK Then
            TextBox1.Text = FolderBrowser.SelectedPath
        End If
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles ExtractInfos.Click
        Label1.Text = Nothing
        Films.Extraction()
        Label1.Text = "Extraction Ok"
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles GetFilms.Click
        ToLV.Enabled = False
        ExtractInfos.Enabled = False

        Films = New FilmCollection
        Films.ScanDirectory(TextBox1.Text)

        ToLV.Enabled = True
        ExtractInfos.Enabled = True

    End Sub

    Private Sub RepertoireVide()

        ListView2.Clear()

        Dim col As New ColumnHeader
        col.Name = "dir"
        col.Text = "directory"
        ' col.Width = 0

        With ListView2.Columns
            .Add(col)
        End With

        Dim lvc As New ListView.ListViewItemCollection(ListView2)
        Dim row As ListViewItem

        For Each element As String In Films.FilmsSansVideo

            Dim r As String() = {element}
            row = New ListViewItem(r)
            row.Name = r(0)
            lvc.Add(row)

        Next

    End Sub

    Private Sub ListingFrm_Load(sender As Object, e As EventArgs) Handles Me.Load
        TextBox1.Text = "\\NAS2\Films"
        ToLV.Enabled = False
        ExtractInfos.Enabled = False
    End Sub

    Private Sub ToLV_Click(sender As Object, e As EventArgs) Handles ToLV.Click
        ListingToListView()
        RepertoireVide()
    End Sub

End Class

